var CodeRunnerStyleWantsDark = false
var CodeRunnerStyleDocumentColor = false
function CodeRunnerStyleCheckNode(element) {
	var inverted = false
	var invert = function(e) {
		e.classList.toggle('coderunner_inverted')
		inverted = !inverted
	}

	var ancestor = element
	do {
		if (ancestor.classList.contains('coderunner_inverted')) {
			inverted = !inverted
		}
	} while (ancestor = ancestor.parentElement)

	if (!CodeRunnerStyleWantsDark && inverted && (element.nodeName == "INPUT" || element.nodeName == "TEXTAREA" || element.nodeName == "SELECT")) {
		invert(element)
		return
	}
	
	var gcs = window.getComputedStyle(element)
	var bg = gcs.backgroundColor
	if (element == document.documentElement && bg == 'rgba(0, 0, 0, 0)') {
		bg = 'rgba(255, 255, 255, 1)'
		element.style.backgroundColor = bg;
	}
	if (bg != 'rgba(0, 0, 0, 0)') {
		var color = getColorComponents(bg)
		var a = CodeRunnerStyleWantsDark ? 0.2 : 0.3
		var isDark = colorIsDark(color)
		if (inverted) {
			isDark = !isDark
		}
		if (CodeRunnerStyleWantsDark != isDark) {
			invert(element)
			if (element == document.documentElement || element.nodeName == "BODY") {
				CodeRunnerStyleDocumentColor = color
			}
			element.style.backgroundColor = "transparent";
		} else {
			if (element == document.documentElement || element.nodeName == "BODY") {
				CodeRunnerStyleDocumentColor = color
				element.style.backgroundColor = "transparent";
			} else {
				var ancestorColor = false
				var ancestor = element
				while (ancestorColor == false && (ancestor = ancestor.parentElement)) {
					if (ancestor.style.backgroundColor.startsWith('rgb')) {
						ancestorColor = ancestor.style.backgroundColor
					}
				}
				if (!ancestorColor) {
					ancestorColor = CodeRunnerStyleDocumentColor
					ancestor = document.body
				} else {
					ancestorColor = getColorComponents(ancestorColor)
				}
				var heightRatio = 0
				if (ancestor) {
					heightRatio = element.offsetHeight/ancestor.offsetHeight
				}
				if (heightRatio < 0.9 && ancestorColor && !equalColors(color, ancestorColor, 10)) {
					color.a = a
					element.style.backgroundColor = colorStringWithComponents(color)
				} else {
					element.style.backgroundColor = 'transparent'
				}
			}
		}
	}
	if (gcs.position == "fixed") {
		if (element.nodeName == "NAV") {
			element.style.position = "absolute"
		} else {
			element.style.display = "none";
		}
	}

	if (gcs.borderBottomWidth != '0px') {
		if (gcs.borderBottomColor != 'rgba(0, 0, 0, 0)') {
			var borderColor = getColorComponents(gcs.borderBottomColor)
			var newBorderColor = colorWithInvertedBrightnessIfNeeded(borderColor, CodeRunnerStyleWantsDark, inverted)
			if (newBorderColor) borderColor = newBorderColor
			borderColor.a = 0.3
			element.style.setProperty("border-bottom-color", colorStringWithComponents(borderColor), "important")
		}
	}
	if (gcs.borderTopWidth != '0px') {
		if (gcs.borderTopColor != 'rgba(0, 0, 0, 0)') {
			var borderColor = getColorComponents(gcs.borderTopColor)
			var newBorderColor = colorWithInvertedBrightnessIfNeeded(borderColor, CodeRunnerStyleWantsDark, inverted)
			if (newBorderColor) borderColor = newBorderColor
			borderColor.a = 0.3
			element.style.setProperty("border-top-color", colorStringWithComponents(borderColor), "important")
		}
	}
	if (gcs.borderLeftWidth != '0px') {
		if (gcs.borderLeftColor != 'rgba(0, 0, 0, 0)') {
			var borderColor = getColorComponents(gcs.borderLeftColor)
			var newBorderColor = colorWithInvertedBrightnessIfNeeded(borderColor, CodeRunnerStyleWantsDark, inverted)
			if (newBorderColor) borderColor = newBorderColor
			borderColor.a = 0.3
			element.style.setProperty("border-left-color", colorStringWithComponents(borderColor), "important")
		}
	}
	if (gcs.borderRightWidth != '0px') {
		if (gcs.borderRightColor != 'rgba(0, 0, 0, 0)') {
			var borderColor = getColorComponents(gcs.borderRightColor)
			var newBorderColor = colorWithInvertedBrightnessIfNeeded(borderColor, CodeRunnerStyleWantsDark, inverted)
			if (newBorderColor) borderColor = newBorderColor
			borderColor.a = 0.3
			element.style.setProperty("border-right-color", colorStringWithComponents(borderColor), "important")
		}
	}

	var color = getColorComponents(gcs.color)
	if (color) {
		color = colorWithInvertedBrightnessIfNeeded(color, CodeRunnerStyleWantsDark, inverted);
		if (color) {
			element.style.setProperty('color', colorStringWithComponents(color), 'important');
		}
	}
	if (inverted) {
		if (element.nodeName == "IMG") {
			invert(element)
		} else {
			if (gcs.backgroundImage.startsWith('url') && element.textContent == "" && element.offsetWidth > 40) {
				invert(element)
			}
		}
	}
	if (element.nodeName == "INPUT" || element.nodeName == "TEXTAREA") {
		if (inverted == CodeRunnerStyleWantsDark) {
			element.style.border = "1px solid rgba(0, 0, 0, 0.15)"
			element.style.backgroundColor = 'rgba(255, 255, 255, 0.1)'
			element.style.color = 'rgba(0, 0, 0, 1.0)';
		} else {
			element.style.border = "1px solid rgba(255, 255, 255, 0.15)"
			element.style.backgroundColor = 'rgba(0, 0, 0, 0.1)'
			element.style.color = 'rgba(255, 255, 255, 1.0)';
		}
	}
}

function CodeRunnerStyleTraverseNodes() {
	CodeRunnerStyleWantsDark = document.documentElement.classList.contains("coderunner_style_dark")
	var elements = document.getElementsByTagName('*')
	for (var i = 0; i < elements.length; i++) {
		CodeRunnerStyleCheckNode(elements[i])
	}
	if (typeof CodeRunnerStyleIgnoreMutations === "undefined" || CodeRunnerStyleIgnoreMutations != true) {
		var observer = new MutationObserver(function (mutations) {
			for (var m = 0; m < mutations.length; m++) {
				var addedNodes = mutations[m].addedNodes
				for (var i = 0; i < addedNodes.length; i++) {
					if (addedNodes[i].nodeType == Node.ELEMENT_NODE)
					CodeRunnerStyleCheckNode(addedNodes[i])
				}
			}
		})
		observer.observe(document.documentElement, { childList:true, subtree: true })
	}
}

function getColorComponents(colorString) {
	if (colorString.startsWith('rgb')) {
		var components = colorString.substring(colorString.indexOf("(")+1, colorString.length-1).split(",")
		var r = parseFloat(components[0])
		var g = parseFloat(components[1])
		var b = parseFloat(components[2])
		var a = components.length > 3 ? parseFloat(components[3]) : 1.0
		return {r:r, g:g, b:b, a:a};
	}
	return false
}

function colorStringWithComponents(color) {
	if (color) {
		return 'rgba('+color.r+', '+color.g+', '+color.b+', '+color.a+')'
	}
	return ''
}

function equalColors(color1, color2, tolerance) {
	return Math.abs(color1.r-color2.r) <= tolerance && Math.abs(color1.g-color2.g) <= tolerance && Math.abs(color1.b-color2.b) <= tolerance && Math.abs(color1.a-color2.a) <= tolerance
}

function colorIsDark(color) {
	var avg = (color.r+color.g+color.b)/3.0
	avg += (255-avg)*(1-color.a)
	return avg < 128
}

function colorWithInvertedBrightnessIfNeeded(color, wantsDark, inverted) {
	var isDark = colorIsDark(color)
	wantsDark = !wantsDark
	if (inverted) {
		isDark = !isDark
	}
	if (isDark != wantsDark) {
		return colorWithInvertedBrightness(color)
	}
	return false
}

function colorWithInvertedBrightness(color) {
	r = color.r, b = color.b, g = color.g
	r /= 255, g /= 255, b /= 255
	var max = Math.max(r, g, b), min = Math.min(r, g, b)
	var h, s, l = (max + min) / 2
	if (max == min) {
		h = s = 0
	} else {
		var d = max - min
		s = l > 0.5 ? d / (2 - max - min) : d / (max + min)
		switch (max) {
			case r: h = (g - b) / d + (g < b ? 6 : 0); break
			case g: h = (b - r) / d + 2; break
			case b: h = (r - g) / d + 4; break
		}
		h /= 6;
	}

	l = 1.0-l

	if (s == 0) {
		r = g = b = l
	} else {
		function hue2rgb(p, q, t) {
			if (t < 0) t += 1
			if (t > 1) t -= 1
			if (t < 1/6) return p + (q - p) * 6 * t
			if (t < 1/2) return q
			if (t < 2/3) return p + (q - p) * (2/3 - t) * 6
			return p
		}
		var q = l < 0.5 ? l * (1 + s) : l + s - l * s
		var p = 2 * l - q
		r = hue2rgb(p, q, h + 1/3)
		g = hue2rgb(p, q, h)
		b = hue2rgb(p, q, h - 1/3)
	}
	return {r: Math.round(r * 255), g: Math.round(g * 255), b: Math.round(b * 255), a: color.a }
}

function CodeRunnerSetAutomaticZoomLevel() {
	var _coderunnerZoomLevel = 0.85
	var _coderunnerFontSize = window.getComputedStyle(document.body).fontSize
	if (_coderunnerFontSize.endsWith('px')) {
		var value = parseFloat(_coderunnerFontSize)
		if (value > 16) {
			_coderunnerZoomLevel *= (16/(value < 24 ? value : 24))
		}
	}
	document.documentElement.style.zoom = _coderunnerZoomLevel
}

var CodeRunnerTocElements = [];

function CodeRunnerBuildToc() {
	CodeRunnerTocElements = [];
	var strip = function (string) {
		var charset = " \t\n\r#¶"
		while (string.length > 0) {
			if (charset.indexOf(string[0]) != -1) {
				string = string.substring(1)
			} else if (charset.indexOf(string[string.length-1]) != -1) {
				string = string.substring(0, string.length-1)
			} else {
				break
			}
		}
		return string
	}
	var result = []
	var list = document.querySelectorAll("h1, h2, h3, h4, h5, h6, [data-coderunner-toc-title], [data-coderunner-toc-level], [data-coderunner-toc-symbol-kind]")
	var indentationLevel = 0
	for (var i = 0; i < list.length; i++) {
		var element = list[i]
		if (element.nodeType != Node.ELEMENT_NODE || element.offsetHeight == 0) {
			continue
		}
		var title = element.hasAttribute("data-coderunner-toc-title") ? strip(element.getAttribute("data-coderunner-toc-title")) : false
		var level = element.hasAttribute("data-coderunner-toc-level") ? element.getAttribute("data-coderunner-toc-level") : ""
		var nodeName = element.nodeName
		var extraLevel = 0
		if (nodeName.length == 2 && nodeName[0] == "H") {
			if (title !== false && title.length == 0) {
				continue
			}
			if (level.length == 0) {
				indentationLevel = parseInt(nodeName[1])-1
			}
		} else if (level.length == 0) {
			extraLevel++
		}
		if (level.length != 0) {
			if (level[0] == "+" || level[0] == "-") {
				extraLevel += parseInt(level)+1
			} else {
				indentationLevel = parseInt(level)
			}
		}
		if (title === false) {
			var text = ""
			var children = Array.prototype.slice.call(element.childNodes)
			for (var j = 0; j < children.length; j++) {
				if (children[j].nodeType == Node.TEXT_NODE) {
					if (children[j].parentElement.offsetHeight != 0) {
						text += children[j].textContent
					}
				} else {
					var grandchildren = children[j].childNodes
					for (var k = 0; k < grandchildren.length; k++) {
						children.splice(j+k+1, 0, grandchildren[k])
					}
				}
			}
			title = strip(text)
		}
		title = title.replace(/\s+/, " ")
		if (title.length != 0) {
			var item = {title: title, indentationLevel: indentationLevel+extraLevel}
			var kind = element.hasAttribute("data-coderunner-toc-symbol-kind") ? element.getAttribute("data-coderunner-toc-symbol-kind") : "section"
			if (kind.length > 0) {
				item["kind"] = kind
			}
			var id = element.id
			if (id.length == 0) {
				id = "coderunner-toc-"+result.length
				element.id = id
			}
			item["id"] = id
			result.push(item)
			CodeRunnerTocElements.push(element)
		}
	}
	if (result.length > 0) {
		var currentTocIndex = CodeRunnerCurrentTocIndex();
		if (currentTocIndex > 0) {
			result[currentTocIndex-1]["selected"] = true
		}
	}
	return result
}

function CodeRunnerCurrentTocIndex() {
	var range = document.caretRangeFromPoint(0, 50)
	if (range) {
		if (window.scrollY > 10) {
			var itemToSelect = 0
			for (var i = 0; i < CodeRunnerTocElements.length; i++) {
				var node = CodeRunnerTocElements[i]
				var nodeRange = document.createRange()
				nodeRange.setStartBefore(node)
				nodeRange.setEndAfter(node)
				if (range.compareBoundaryPoints(Range.START_TO_START, nodeRange) != -1) {
					itemToSelect = i+1
				} else {
					break
				}
			}
			return itemToSelect
		}
	} else {
		return -1
	}
	return 0
}

var tables = document.getElementsByTagName("table")
for (var i = 0; i < tables.length; i++){
	var div = document.createElement("div")
	div.style.overflowX = "auto"
	div.style.wordBreak = "normal"
	tables[i].parentNode.insertBefore(div, tables[i])
	div.appendChild(tables[i])
}

window.addEventListener("scroll", function () {
	webkit.messageHandlers.scrollUpdate.postMessage(CodeRunnerCurrentTocIndex())
})

window.addEventListener("load", function () {
	setTimeout(function () {
		webkit.messageHandlers.scrollUpdate.postMessage(CodeRunnerCurrentTocIndex())
	}, 500)
})

window.addEventListener("scroll", function () {
	if (window.scrollX < 0) {
		window.scroll(0, window.scrollY)
	} else if (window.scrollX > document.body.scrollWidth-window.innerWidth) {
		window.scroll(document.body.scrollWidth-window.innerWidth, window.scrollY)
	}
})
